gtksourceviewmm: Gsv::CompletionProvider Class Reference

gtksourceviewmm 3.2.0

- Main Page
- Related Pages
- Modules
- Classes

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Related Functions
Gsv::CompletionProvider Class Reference

Completion provider interface. More...

`#include <gtksourceviewmm/completionprovider.h>`

Inheritance diagram for Gsv::CompletionProvider:
[legend]

List of all members.

## Public Member Functions
GtkSourceCompletionProvider* | gobj ()
| Provides access to the underlying C GObject.
const GtkSourceCompletionProvider* | gobj () const
| Provides access to the underlying C GObject.
Glib::ustring | get_name () const
| Get the name of the provider.
Glib::RefPtr< Gdk::Pixbuf > | get_icon ()
| Get the icon of the provider.
Glib::RefPtr< const Gdk::Pixbuf > | get_icon () const
| Get the icon of the provider.
void | populate (const Glib::RefPtr< CompletionContext >& context)
| Populate context with proposals from a provider.
bool | match (const Glib::RefPtr< const CompletionContext >& context) const
| Get whether the provider match the context of completion detailed in context.
Gtk::Widget* | get_info_widget (const Glib::RefPtr< const CompletionProposal >& proposal)
| Get a customized info widget to show extra information of a proposal.
const Gtk::Widget* | get_info_widget (const Glib::RefPtr< const CompletionProposal >& proposal) const
| Get a customized info widget to show extra information of a proposal.
void | update_info (const Glib::RefPtr< const CompletionProposal >& proposal, const CompletionInfo& info)
| Update extra information shown in info for proposal.
bool | get_start_iter (const Glib::RefPtr< const CompletionContext >& context, const Glib::RefPtr< const CompletionProposal >& proposal, Gtk::TextIter& iter)
| Get the Gtk::TextIter at which the completion for proposal starts.
bool | activate_proposal (const Glib::RefPtr< CompletionProposal >& proposal, const Gtk::TextIter& iter)
| Activate proposal at iter.
CompletionActivation | get_activation () const
| Get with what kind of activation the provider should be activated.
int | get_interactive_delay () const
| Get the delay in milliseconds before starting interactive completion for this provider.
int | get_priority () const
| Get the provider priority.
## Related Functions
(Note that these are not member functions.)
Glib::RefPtr < Gsv::CompletionProvider > | wrap (GtkSourceCompletionProvider* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

Completion provider interface.

You must implement this interface to provide proposals to Completion.

Since gtksourceviewmm 2.10:

## Member Function Documentation

bool Gsv::CompletionProvider::activate_proposal | ( | const Glib::RefPtr< CompletionProposal >& | proposal,
|  | const Gtk::TextIter & | iter
| ) |  |

Activate proposal at iter.

When this functions returns `false`, the default activation of proposal will take place which replaces the word at iter with the label of proposal.

Parameters:

  proposal | A CompletionProposal.
  iter | A Gtk::TextIter.

Returns:
  `true` to indicate that the proposal activation has been handled, `false` otherwise.

Since gtksourceviewmm 2.10:

CompletionActivation Gsv::CompletionProvider::get_activation | ( |  | ) | const

Get with what kind of activation the provider should be activated.

Returns:
  A combination of CompletionActivation.

Since gtksourceviewmm 2.10:

Glib::RefPtr<Gdk::Pixbuf> Gsv::CompletionProvider::get_icon | ( |  | ) |

Get the icon of the provider.

Returns:
  The icon to be used for the provider, or empty Glib::RefPtr if the provider does not have a special icon.

Since gtksourceviewmm 2.10:

Glib::RefPtr<const Gdk::Pixbuf> Gsv::CompletionProvider::get_icon | ( |  | ) | const

Get the icon of the provider.

Returns:
  The icon to be used for the provider, or empty Glib::RefPtr if the provider does not have a special icon.

Since gtksourceviewmm 2.10:

Gtk::Widget* Gsv::CompletionProvider::get_info_widget | ( | const Glib::RefPtr< const CompletionProposal >& | proposal | ) |

Get a customized info widget to show extra information of a proposal.

This allows for customized widgets on a proposal basis, although in general providers will have the same custom widget for all their proposals and proposal can be ignored. The implementation of this function is optional. If implemented, update_info() must also be implemented. If not implemented, the default get_info() will be used to display extra information about a CompletionProposal.

Parameters:

  proposal | The currently selected CompletionProposal.

Returns:
  A custom Gtk::Widget to show extra information about proposal.

Since gtksourceviewmm 2.10:

const Gtk::Widget* Gsv::CompletionProvider::get_info_widget | ( | const Glib::RefPtr< const CompletionProposal >& | proposal | ) | const

Get a customized info widget to show extra information of a proposal.

This allows for customized widgets on a proposal basis, although in general providers will have the same custom widget for all their proposals and proposal can be ignored. The implementation of this function is optional. If implemented, update_info() must also be implemented. If not implemented, the default get_info() will be used to display extra information about a CompletionProposal.

Parameters:

  proposal | The currently selected CompletionProposal.

Returns:
  A custom Gtk::Widget to show extra information about proposal.

Since gtksourceviewmm 2.10:

int Gsv::CompletionProvider::get_interactive_delay | ( |  | ) | const

Get the delay in milliseconds before starting interactive completion for this provider.

A value of -1 indicates to use the default value as set by Completion::property_auto_complete_delay().

Returns:
  The interactive delay in milliseconds.

Since gtksourceviewmm 2.10:

Glib::ustring Gsv::CompletionProvider::get_name | ( |  | ) | const

Get the name of the provider.

This should be a translatable name for display to the user. For example: _("Document word completion provider"). The returned string must be freed with Glib::free().

Returns:
  A new string containing the name of the provider.

int Gsv::CompletionProvider::get_priority | ( |  | ) | const

Get the provider priority.

The priority determines the order in which proposals appear in the completion popup. Higher priorities are sorted before lower priorities. The default priority is 0.

Returns:
  The provider priority.

Since gtksourceviewmm 2.10:

bool Gsv::CompletionProvider::get_start_iter | ( | const Glib::RefPtr< const CompletionContext >& | context,
|  | const Glib::RefPtr< const CompletionProposal >& | proposal,
|  | Gtk::TextIter & | iter
| ) |  |

Get the Gtk::TextIter at which the completion for proposal starts.

When implemented, the completion can use this information to position the completion window accordingly when a proposal is selected in the completion window.

Parameters:

  proposal | A CompletionProposal.
  context | A CompletionContext.
  iter | A Gtk::TextIter.

Returns:
  `true` if iter was set for proposal, `false` otherwise.

Since gtksourceviewmm 2.10:

bool Gsv::CompletionProvider::match | ( | const Glib::RefPtr< const CompletionContext >& | context | ) | const

Get whether the provider match the context of completion detailed in context.

Parameters:

  context | The CompletionContext.

Returns:
  `true` if provider matches the completion context, `false` otherwise.

Since gtksourceviewmm 2.10:

void Gsv::CompletionProvider::populate | ( | const Glib::RefPtr< CompletionContext >& | context | ) |

Populate context with proposals from a provider.

Parameters:

  context | The CompletionContext.

Since gtksourceviewmm 2.10:

void Gsv::CompletionProvider::update_info | ( | const Glib::RefPtr< const CompletionProposal >& | proposal,
|  | const CompletionInfo& | info
| ) |  |

Update extra information shown in info for proposal.

This should be implemented if your provider sets a custom info widget for proposal. This function must be implemented when get_info_widget() is implemented.

Parameters:

  proposal | A CompletionProposal.
  info | A CompletionInfo.

Since gtksourceviewmm 2.10:

## Friends And Related Function Documentation

Glib::RefPtr< Gsv::CompletionProvider > wrap | ( | GtkSourceCompletionProvider * | object,
|  | bool | take_copy = `false`
| ) |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.